<template>
  <div class="group-list">
    <ul>
      <li v-for="group in groups" :key="group.id" v-on:click="handleClick(group.id)" :class="{ current: isCurrent(group.id)}">
        {{ group.name }}
      </li>
    </ul>
  </div>
</template>
<script lang="ts">
import Vue from 'vue';
import { mapActions, mapGetters } from 'vuex';
import { SelectGroupAction, LoadGroupsAction } from '@/store/actions';
import { currentGroupId, groups } from '@/store/getters';

export default Vue.component('GroupList', {
  data: () => ({
  }),
  methods: {
    async handleClick(id: string) {
      await this.$store.dispatch(new SelectGroupAction(id));
    },
    isCurrent(id: string) {
      return id === this.currentGroupId;
    },
  },
  computed: mapGetters({
    currentGroupId,
    groups,
  }),
  beforeCreate() {
    this.$store.dispatch(new LoadGroupsAction());
  },
});
</script>
<style lang="scss" scoped>
.current {
  background-color: lighten(#000, 90%);
}
li {
  cursor: pointer;
  list-style: none;
  padding: 5px;
}
ul {
  padding: 0;
  margin: 0;
}
</style>
